
(* The type of tokens. *)

type token = 
  | YIELDS
  | WHILE
  | VERSION of (Lang_string.Version.t)
  | VARLPAR of (string)
  | VARLBRA of (string)
  | VAR of (string)
  | UNDERSCORE
  | UMINUS
  | TRY
  | TO
  | TIMES
  | TIME of (Parsed_term.time_el)
  | TILD
  | THEN
  | STRING of (char * string )
  | SLASH
  | SET
  | SEQSEQ
  | SEQ
  | RPAR
  | REPLACES
  | REGEXP of (string * char list )
  | RCUR
  | RBRA
  | QUESTION_DOT
  | QUESTION
  | PP_STRING of (char * string * Parsed_term.pos)
  | PP_REGEXP of (string * char list * Parsed_term.pos)
  | PP_INT_DOT_LCUR of (string)
  | PP_IFVERSION
  | PP_IFENCODER of (bool)
  | PP_IFDEF of (bool)
  | PP_ENDL
  | PP_ENDIF
  | PP_ELSE
  | OR
  | OPEN
  | NOT
  | MINUS
  | LPAR
  | LETLBRA of (Parser_helper.lexer_let_decoration)
  | LET of (Parser_helper.lexer_let_decoration)
  | LCUR
  | LBRA
  | INTERVAL of (Parsed_term.time_el * Parsed_term.time_el)
  | INTERPOLATED_STRING of (string)
  | INT of (string)
  | INCLUDE of (Parsed_term.inc)
  | IF
  | GETS
  | GET
  | FUN
  | FOR
  | FLOAT of (string)
  | FINALLY
  | EOF
  | END_INTERPOLATION
  | END
  | ENCODER of (string)
  | ELSIF
  | ELSE
  | DOTVAR of (string)
  | DOTDOTDOT
  | DOT
  | DO
  | DEF of (Parser_helper.lexer_let_decoration)
  | COMMA
  | COLONCOLON
  | COLON
  | COALESCE
  | CATCH
  | BOOL of (bool)
  | BIN3 of (string)
  | BIN2 of (string)
  | BIN1 of (string)
  | BEGIN_INTERPOLATION of (char)
  | BEGIN
  | AT
  | ARGS_OF
  | AND

(* This exception is raised by the monolithic API functions. *)

exception Error

(* The monolithic API. *)

val time_predicate: (Lexing.lexbuf -> token) -> Lexing.lexbuf -> (Parsed_term.t)

val program: (Lexing.lexbuf -> token) -> Lexing.lexbuf -> (Parsed_term.t)

val plain_encoder_params: (Lexing.lexbuf -> token) -> Lexing.lexbuf -> (Parser_helper.Term.encoder_params)

val interactive: (Lexing.lexbuf -> token) -> Lexing.lexbuf -> (Parsed_term.t)

val annotate_metadata_entry: (Lexing.lexbuf -> token) -> Lexing.lexbuf -> (string * string)

val annotate: (Lexing.lexbuf -> token) -> Lexing.lexbuf -> ((string * string) list)
